



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU5008 Boring String Problem(后缀数组)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU5008 Boring String Problem(后缀数组)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 18:28:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>练习一下字符串，做一下这道题。</p>
<p>首先是关于一个字符串有多少不同子串的问题，串由小到大排起序来应该是按照sa[i]的顺序排出来的产生的。</p>
<p>好像abbacd，排序出来的后缀是这样的</p>
<p>1---abbacd &nbsp; &nbsp; 第一个串产生的6个前缀都是新的子串</p>
<p>2---acd &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;第二个串除了和上一个串的前缀1 3-1=2 产生了2个子串</p>
<p>3---bacd &nbsp; &nbsp; &nbsp; &nbsp;4-0=4</p>
<p>4---bbacd &nbsp; &nbsp; &nbsp;5-1=4</p>
<p>5---cd &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2－0=0</p>
<p>6---d &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1－0=0</p>
<p>所以所有不同的前缀应该是(len-sa[i])-lcp[i-1]的和，即串长减去与上一个串的最长公共前缀，然后求和。</p>
<p>所以我们可以预处理出dp[i]表示sa[i]的后缀所产生的新串的个数，然后对dp[i]求一次前缀和，那么每次询问第k大的串的时候就可以直接lower_bound，找出串的左端和右端。但是这个(l,r)不一定是最小的，最小的可能是在sa[i+1]..sa[i+2]...里产生，所以我们首先要二分出合法的sa边界，即sa[i]....sa[j]里都可以产生的这个串，然后sa[i]...sa[j]的最小值即是我们要求的。写二分总是要跪要跪的－ －0</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;string&gt;<br />
#include &lt;numeric&gt;<br />
#include &lt;cassert&gt;<br />
using namespace std;

#define maxn 120000<br />
#define ll long long

struct SuffixArray<br />
{<br />
    int n;<br />
    int m[2][maxn];<br />
    int sa[maxn];<br />
    char s[maxn];

    void indexSort(int sa[], int ord[], int id[], int nId){<br />
        static int cnt[maxn];<br />
        memset(cnt, 0, sizeof(0)*nId);<br />
        for (int i = 0; i &lt; n; i++){<br />
            cnt[id[i]]++;<br />
        }<br />
        partial_sum(cnt, cnt + nId, cnt);<br />
        for (int i = n - 1; i &gt;= 0; i--){<br />
            sa[--cnt[id[ord[i]]]] = ord[i];<br />
        }<br />
    }

    int *id, *oId;

    void init(){<br />
        n = strlen(s) + 1;<br />
        static int w[maxn];<br />
        for (int i = 0; i &lt;= n; i++) w[i] = s[i];<br />
        sort(w, w + n);<br />
        int nId = unique(w, w + n) - w;<br />
        id = m[0], oId = m[1];<br />
        for (int i = 0; i &lt; n; i++){<br />
            id[i] = lower_bound(w, w + nId, s[i]) - w;<br />
        }<br />
        static int ord[maxn];<br />
        for (int i = 0; i &lt; n; i++){<br />
            ord[i] = i;<br />
        }<br />
        indexSort(sa, ord, id, nId);<br />
        for (int k = 1; k &lt;= n&amp;&amp;nId &lt; n; k &lt;&lt;= 1){<br />
            int cur = 0;<br />
            for (int i = n - k; i &lt; n; i++){<br />
                ord[cur++] = i;<br />
            }<br />
            for (int i = 0; i &lt; n; i++){<br />
                if (sa[i] &gt;= k) ord[cur++] = sa[i] - k;<br />
            }<br />
            indexSort(sa, ord, id, nId);<br />
            cur = 0;<br />
            swap(oId, id);<br />
            for (int i = 0; i &lt; n; i++){<br />
                int c = sa[i], p = i ? sa[i - 1] : 0;<br />
                id[c] = (i == 0 || oId[c] != oId[p] || oId[c + k] != oId[p + k]) ? cur++ : cur - 1;<br />
            }<br />
            nId = cur;<br />
        }<br />
    }

    // lcp relevant<br />
    int rk[maxn], lcp[maxn];<br />
    void getlcp(){<br />
        for (int i = 0; i &lt; n; i++) rk[sa[i]] = i;<br />
        int h = 0;<br />
        lcp[0] = 0;<br />
        for (int i = 0; i &lt; n; i++){<br />
            int j = sa[rk[i] - 1];<br />
            for (h ? h-- : 0; i + h &lt; n&amp;&amp;j + h &lt; n&amp;&amp;s[i + h] == s[j + h]; h++);<br />
            lcp[rk[i] - 1] = h;<br />
        }<br />
    }

    // lcp query relevant<br />
    int d[maxn + 50][25];<br />
    int mi[maxn+50][25];

    void getrmq(){<br />
        for (int i = 0; i &lt; n; i++) d[i][0] = lcp[i];<br />
        for (int j = 1; (1 &lt;&lt; j) &lt; n; j++){<br />
            for (int i = 0; (i + (1 &lt;&lt; j) - 1) &lt; n; i++){<br />
                d[i][j] = min(d[i][j - 1], d[i + (1 &lt;&lt; (j - 1))][j - 1]);<br />
            }<br />
        }<br />
        for(int i=0;i&lt;n;i++) mi[i][0]=sa[i];<br />
        for (int j = 1; (1 &lt;&lt; j) &lt; n; j++){<br />
            for (int i = 0; (i + (1 &lt;&lt; j) - 1) &lt; n; i++){<br />
                mi[i][j] = min(mi[i][j - 1], mi[i + (1 &lt;&lt; (j - 1))][j - 1]);<br />
            }<br />
        }<br />
    }

    int rmq_query3(int l,int r){<br />
        if(l==r) return mi[l][0];<br />
        int k=0;int len=r-l+1;<br />
        while((1&lt;&lt;(k+1))&lt;len) ++k;<br />
        return min(mi[l][k], mi[r - (1 &lt;&lt; k) + 1][k]);<br />
    }

    int rmq_query(int l, int r){<br />
        if(l==r) return n-1-sa[l];<br />
        if (l &gt; r) swap(l, r); r -= 1;<br />
        int k = 0; int len = r - l + 1;<br />
        while ((1 &lt;&lt; (k + 1)) &lt; len) k++;<br />
        return min(d[l][k], d[r - (1 &lt;&lt; k) + 1][k]);<br />
    }

    int rmq_query2(int l, int r){<br />
        l = rk[l], r = rk[r];<br />
        if (l &gt; r) swap(l, r); r -= 1;<br />
        int k = 0; int len = r - l + 1;<br />
        while ((1 &lt;&lt; (k + 1)) &lt; len) k++;<br />
        return min(d[l][k], d[r - (1 &lt;&lt; k) + 1][k]);<br />
    }<br />
}sa;

int nQ;<br />
ll dp[maxn];<br />
int n;<br />
int main()<br />
{<br />
    while(~scanf("%s",sa.s)){<br />
        sa.init();<br />
        sa.getlcp();<br />
        sa.getrmq();<br />
        n=sa.n-1;<br />
        dp[0]=0;<br />
        for(int i=1;i&lt;=n;++i){<br />
            dp[i]=n-sa.sa[i]-sa.lcp[i-1];<br />
            dp[i]+=dp[i-1];<br />
        }<br />
        ll ansl=0,ansr=0;<br />
        ll ki;<br />
        scanf("%d",&amp;nQ);<br />
        while(nQ--){<br />
            scanf("%I64d",&amp;ki);<br />
            ki=(ki^ansl^ansr)+1;<br />
            if(ki&gt;dp[n]){<br />
                ansl=ansr=0;<br />
                printf("%d %d\n",ansl,ansr);<br />
                continue;<br />
            }<br />
            int tl,tr;<br />
            int id=lower_bound(dp,dp+n+1,ki)-dp;<br />
            tl=sa.sa[id];<br />
            tr=tl+sa.lcp[id-1]+ki-dp[id-1]-1;<br />
            int len=tr-tl+1;<br />
            int lf=id,rf=n;<br />
            while(lf&lt;rf){<br />
                int mid=(lf+rf+1)&gt;&gt;1;<br />
                if(sa.rmq_query(id,mid) &gt;= len) lf=mid;<br />
                else rf=mid-1;<br />
            }<br />
            ansl=sa.rmq_query3(id,lf)+1;<br />
            ansr=ansl+len-1;<br />
            printf("%I64d %I64d\n",ansl,ansr);<br />
        }<br />
    }<br />
    return 0;<br />
}
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ng1v9.html">java重载和重写的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3dj1q.html">Python 基礎 - 字符編碼</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gg6m8.html">Ajax请求WebService跨域问题 &lbrack;转载&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgg4r8.html">国产ProcessOn和国外gliffy的对比区别【原创】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pje5k49.html">Win&plus;R指令&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjj1wy8.html">windows平台搭建lighttpd&plus;php&plus;sqlite</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdroe8.html">MVC ValidationAttribute 服务器端自定义验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdol19.html">php imagemagick 处理 图片剪切、压缩、合并、插入文本、背景色透明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6llnq.html">201521123089 《Java程序设计》第1周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkz648.html">GJB150-2009军用装备实验室环境试验方法新版标准</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg3xy78.html">Delphi子窗体随主窗体大小而变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6e748.html">MaxPooling的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdr3yy9.html">WPF效果（GIS三维续篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10gml9.html">Python实例之抓取淘宝商品数据（json型数据）并保存为TXT</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwgg6x9.html">iOS 弹幕制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m243p6q.html">Android使得Fragment 切换时不重新实例化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynd0d9.html">Google Protobuf结合Netty实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emm4le9.html">SQL 分页 SQL SERVER 2008</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emmp1x9.html">Mapper method &amp;&num;39&semi;com&period;autoyol&period;mapper&period;trans&period;AccountLogMapper&period;getTotalIncomByMemNoLastest attempted to return null from a method with a primitive return type &lpar;int&rpar;&period;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn4n1rq.html">fstream 和 iostream</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn1n6jg8.html">菜鸟学习Hibernate&mdash;&mdash;一对多关系映射</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x3l3m8.html">【转】SQLite提示database disk image is malformed的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1mkdz9.html">Erlang generic standard behaviours -- gen&lowbar;server module</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydvj4mq.html">Linux开机启动程序详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1mvjm9.html">以Lockbits的方式访问bitmap</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o3v3j9.html">关于VS2010error RC2170 &colon; bitmap file res&bsol;tmp1&period;bmp is not in 3&period;00 format</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xp07z9.html">21、HierarchyViewer使用记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdokkr8.html">SQL Server性能优化（1）使用SET函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmne79.html">mac os 10&period;10上安装my eclipse显示virtual memory不足，解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmny79.html">gvim编辑文件到github乱码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
